#$Header: /raid/cvsroot/DBIx/Record/Record.pm,v 1.19 2000/01/18 05:36:01 jesse Exp $
package DBIx::Record;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);
require Exporter;
require AutoLoader;

@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);
$VERSION = '0.01';

# Preloaded methods go here.

$DBIx::Record::Debug = 1; 

sub AUTOLOAD {
  my $self = shift;
  
  no strict 'refs';


  if ($AUTOLOAD =~ /.*::(\w+)/ && $self->_Accessible($1,'read')) {
    my $Attrib = $1;

    *{$AUTOLOAD} = sub { return ($_[0]->_Value($Attrib))};
    return($self->_Value($Attrib));
  }
    
  elsif ($AUTOLOAD =~ /.*::Set(\w+)/ && $self->_Accessible($1,'write')) {
    my $Attrib = $1;

    *{$AUTOLOAD} = sub {  return ($_[0]->_Set($Attrib, $_[1]))};
    my $Value = shift @_;
    return($self->_Set($Attrib, $Value));
    }

  elsif ($AUTOLOAD =~ /.*::Validate(\w+)/ && $self->_Accessible($1,'write')) {
    my $Attrib = $1;

    *{$AUTOLOAD} = sub {  return ($_[0]->_Validate($Attrib, $_[1]))};
    my $Value = shift @_;
    return($self->_Validate($Attrib, $Value));
    }

  
  else {
    my ($package, $filename, $line);
    ($package, $filename, $line) = caller;

    die "$AUTOLOAD Unimplemented in $package. ($filename line $line) \n";
  }
  
}


#instantiate a new record object.
  sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self  = {};
    bless ($self, $class);
    return $self;
    $self->_Init(@_);
  }
  

sub _Accessible {
  my $self = shift;
  my $Attrib = shift;
  my $Mode = shift;
  my %Cols = @_;

  #  return true if we can $mode $Attrib;
  #return 0 if it's not a valid attribute;
  if (!$Cols{"$Attrib"}) { return(0)}
 # print "Atrib: $Attrib: $Cols{$Attrib} '$Mode'\n";

  $Cols{$Attrib} =~ /$Mode/;
  
}

  
  sub _MyHandle {
    my $self = shift;
    my %args = ( Handle=> undef,
		 @_
	       );
    $self->{'DBIxHandle'} = $args{'Handle'};

  }
  
  sub _set_and_return {
    my $self =shift;
    die "_set_and_return deprecated\n";
  }
  
  


  sub _Value {
    my $self = shift;
    my $field = shift;
    if ($self->{'values'}->{"$field"}) {
      return($self->{'values'}->{"$field"});
    }
    else {
      return(undef);
    }
  }

  sub _Set {
    my $self = shift;
    my $field = shift;
    my $value = shift; 
    my ($error_condition);
    #print "$self -> _Set $field->$value\n";


    if (!$field) {
      return ("No field sent to _Set!\n");
    }
    elsif ($value eq undef ) {
      return ("No value sent to _Set!\n");
      }
    elsif ($value ne $self->_Value($field)) {
     #TODO $self->_Validate($field, $value);
			$error_condition = $self->{'DBIxHandle'}->UpdateTableValue($self->{'table'}, $field,$value,$self->id);
      $self->{'values'}->{"$field"} = $value;
      return (1, "The new value has been set.");
    }
    else {
      return (0, "That is already the current value");
    }
    
    
  }
  sub _Validate {
		my $self = shift;
		my $field = shift;
		my $value = shift;
 
	#Check type of input
	#If it's null, are nulls permitted?
	#If it's an int, check the # of bits
	#If it's a string, 
		#check length
		#check for nonprintables
	#If it's a blob, check for length
	#In an ideal world, if this is a link to another table, check the dependency.
	


	}	
	
  # Functions which return data
  sub Id {
    my $self = shift;
    return ($self->{'values'}->{'id'});
  }
  sub id {
    my $self = shift;
    return ($self->Id);
  }
  
  
  # load should do a bit of overloading
  # if we call it with only one argument, we're trying to load by reference.
  # if we call it with a passel of arguments, we're trying to load by value
  # The latter is primarily important when we've got a whole set of record that we're
  # reading in with a recordset class and want to instantiate objefcts for each record.
  sub load {
    my $self = shift;
    return($self->Load(@_));
  } 
  sub Load {
    my $self = shift;
    #  f (#@_ > 2) {
    #	    $self->LoadByCol(@_);
    #	}
    #	else {
    my ($package, $filename, $line) = caller;
    #print STDERR "DBIx::Record::Load called from $package, line $line with arguments (",@_,")\n" if $DBIx::Record::Debug;
    $self->LoadById(@_);
    #	}
  }
  
  # TODO
  # load by value is intended to be called when it's loading a 
  # bunch of attestations. it takes a hash of the values of the record and
  # instantiates the object from that. 
  
  sub load_by_col {
    my $self = shift;
    return($self->LoadByCol(@_));
  }
  sub LoadByCol {
    my $self = shift;
    my $col = shift;
    my $val = shift;
    
    $val = $self->_Handle->quote($val);
    my $QueryString = "SELECT  * FROM ".$self->{'table'}." WHERE $col = $val";
    return ($self->_LoadFromSQL($QueryString));
  }
  
  sub LoadById {
    my $self = shift;
    my $id = shift;
    
    my $QueryString = "SELECT  * FROM ".$self->{'table'}." WHERE id = $id";
    
    return ($self->_LoadFromSQL($QueryString));
  }
  
  
  sub _LoadFromSQL {
    my $self = shift;
    my $QueryString = shift;
    
    my ($hash, $sth);
    
    $sth = $self->_Handle->prepare($QueryString);
    
    print "QueryString: $QueryString\n";
    
    if (!$sth) {
      die "Error:" . $self->_Handle->errstr . "\n";
    }
    if (!$sth->execute) {
          my ($package, $filename, $line);
	  ($package, $filename, $line) = caller;
	  die "Error:" . $sth->errstr . "\n$QueryString\nWe got called from $package, line $line.\n$filename. ";
    }
    #TODO this only gets the first row. we should check to see if there are more.
    $self->{'values'} = $sth->fetchrow_hashref;
    #$self->{'values'}->{'id'} = $id;
  }
  
  sub Create {
    my $self = shift;
    my @keyvalpairs = (@_);
    
    my ($QueryString, $value, $key, $cols, $vals);
    
    while ($key = shift @keyvalpairs) {
      $value = shift @keyvalpairs;
    
      $cols .= $key . ", ";
      $vals .= $self->{'DBIxHandle'}->safe_quote($value).", ";
      
    }	
    
    $cols =~ s/, $//;
    $vals =~ s/, $//;
    #TODO Check to make sure the key's not already listed.
    #TODO update internal data structure
    $QueryString = "INSERT INTO ".$self->{'table'}." ($cols) VALUES ($vals)";

    print STDERR "$QueryString\n";

    my $sth = $self->_Handle->prepare($QueryString);
    if (!$sth) {
      
      if ($main::debug) {
	die "Error:" . $self->_Handle->errstr . "\n";
      }
      else {
	return (0);
	
      }
    }
    if (!$sth->execute) {
      if ($main::debug) {
	die "Error:" . $sth->errstr . "\n";
      }
      else {
	return(0);
      }
      
    }
    
    $self->{'id'}=$sth->{'mysql_insertid'};
    
    return( $self->{'id'}); #Add Succeded. return the id
  }
  
  

  sub delete {
    my $self = shift;
    return ($self->Delete(@_));
  }

  sub Delete {
    my $self = shift;
    
    my $QueryString;
    
    #TODO Check to make sure the key's not already listed.
    #TODO Update internal data structure
    $QueryString = "DELETE FROM ".$self->{'table'} . " WHERE id  = ". $self->id();
    my $sth = $self->_Handle->prepare($QueryString);
    if (!$sth) {
      if ($main::debug) {
	die "Error:" . $self->_Handle->errstr . "\n";
      }
      else {
	return (0);
      }
    }
    if (!$sth->execute) {
      if ($main::debug) {
	die "Error:" . $sth->errstr . "\n";
      }
      else {
	return(0);
      }

    }
    
    return (1);		#Update Succeded
  }
  
  

sub _Handle {
  my $self = shift;
  return ($self->{'DBIxHandle'}->Handle);
  
}

1;
# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

DBIx::Record - Perl extension for subclassing, so you can deal with a Record

=head1 SYNOPSIS

  use DBIx::Record;

=head1 DESCRIPTION

Stub documentation for DBIx::Record was created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head1 AUTHOR

Jesse Vincent, jesse@fsck.com

=head1 SEE ALSO

perl(1).

=cut
